Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/BenchmarkSuite/PushBenchmarkSuiteSolution.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/BenchmarkSuite/PushBenchmarkSuiteSolution.cs	(revision 15289)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/BenchmarkSuite/PushBenchmarkSuiteSolution.cs	(revision 15289)
@@ -0,0 +1,33 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Solution.BenchmarkSuite {
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Evaluator;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+
+  [StorableClass]
+  public class PushBenchmarkSuiteSolution : PushSolution {
+    public PushBenchmarkSuiteSolution(
+      PushProgram program,
+      double quality,
+      IRandom random,
+      IReadOnlyPushConfiguration config,
+      PushBenchmarkSuiteEvaluator evaluator,
+      bool simplify = false) : base(program, quality, random, config, evaluator, simplify) {
+    }
+
+    public PushBenchmarkSuiteSolution(PushBenchmarkSuiteSolution origin, Cloner cloner) : base(origin, cloner) { }
+
+    [StorableConstructor]
+    public PushBenchmarkSuiteSolution(bool deserializing) : base(deserializing) { }
+
+    public override PushSolution Simplify() {
+      return new PushBenchmarkSuiteSolution(Program, Quality, Random, Config, (PushBenchmarkSuiteEvaluator)Evaluator, true);
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PushBenchmarkSuiteSolution(this, cloner);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/IPushSolution.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/IPushSolution.cs	(revision 15289)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/IPushSolution.cs	(revision 15289)
@@ -0,0 +1,7 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Solution {
+  using HeuristicLab.Core;
+
+  public interface IPushSolution : IItem {
+
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/PushSolution.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/PushSolution.cs	(revision 15289)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/PushSolution.cs	(revision 15289)
@@ -0,0 +1,64 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Solution {
+  using Common;
+  using Configuration;
+  using Core;
+  using Evaluator;
+  using Expressions;
+  using Persistence.Default.CompositeSerializers.Storable;
+
+  [StorableClass]
+  public class PushSolution : NamedItem, IPushSolution {
+    [Storable]
+    public readonly double Quality;
+    [Storable]
+    protected readonly IRandom Random;
+    [Storable]
+    public readonly IReadOnlyPushConfiguration Config;
+    [Storable]
+    public readonly IPushEvaluator Evaluator;
+    [Storable]
+    protected readonly bool simplify;
+    [Storable]
+    public PushProgram Program;
+
+
+    public PushSolution(PushProgram program, double quality, IRandom random, IReadOnlyPushConfiguration config, IPushEvaluator evaluator, bool simplify = false)
+      : base("Solution", "A push solution.") {
+      Quality = quality;
+      Random = random;
+      Config = config;
+      Evaluator = evaluator;
+      this.simplify = simplify;
+
+      Program = simplify
+        ? Simplifier.Simplifier.Simplify(program, Config, p => Evaluator.EvaluateTraining(Config, p, Random).AvgQuality)
+        : program;
+
+    }
+
+    public PushSolution(PushSolution origin, Cloner cloner) : base(origin, cloner) {
+      Program = cloner.Clone(origin.Program);
+      Quality = origin.Quality;
+      Random = cloner.Clone(origin.Random);
+      Config = cloner.Clone(origin.Config);
+      Evaluator = cloner.Clone(origin.Evaluator);
+      Program = origin.Program; // push programs are immutable like all expressions
+      simplify = origin.simplify;
+    }
+
+    public IRandom GetRandom() {
+      return (IRandom)Random.Clone();
+    }
+
+    public virtual PushSolution Simplify() {
+      return new PushSolution(Program, Quality, Random, Config, Evaluator, true);
+    }
+
+    [StorableConstructor]
+    protected PushSolution(bool deserializing) : base(deserializing) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PushSolution(this, cloner);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/IPlushCreator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/IPlushCreator.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/IPlushCreator.cs	(revision 15289)
@@ -12,4 +12,5 @@
     IValueLookupParameter<IntValue> MinCloseParameter { get; }
     IValueLookupParameter<IntValue> MaxCloseParameter { get; }
+    IValueLookupParameter<DoubleValue> CloseBiasLevelParameter { get; }
     IValueLookupParameter<PercentValue> InInstructionProbabilityParameter { get; }
     IValueLookupParameter<IReadOnlyErcOptions> ErcOptionsParameter { get; }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PlushCreator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PlushCreator.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PlushCreator.cs	(revision 15289)
@@ -77,5 +77,5 @@
       get { return (IValueLookupParameter<IntValue>)Parameters["MaxClose"]; }
     }
-    public IValueLookupParameter<DoubleValue> CloseBiasLevel
+    public IValueLookupParameter<DoubleValue> CloseBiasLevelParameter
     {
       get { return (IValueLookupParameter<DoubleValue>)Parameters["CloseBiasLevel"]; }
@@ -99,5 +99,5 @@
       var minClose = MinCloseParameter.ActualValue.Value;
       var maxClose = MaxCloseParameter.ActualValue.Value;
-      var biasLevel = CloseBiasLevel.ActualValue.Value;
+      var biasLevel = CloseBiasLevelParameter.ActualValue.Value;
 
       if (minLength > maxLength)
@@ -111,5 +111,10 @@
 
       for (var i = 0; i < length; i++) {
-        var expression = CodeGeneratorUtils.GetRandomExpression(random, ercOptions, instructions, inInstructionProbability);
+        var expression = CodeGeneratorUtils.GetRandomExpression(
+          random,
+          ercOptions,
+          instructions,
+          inInstructionProbability);
+
         var close = random.NextBiased(minClose, maxClose, biasLevel);
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PushSolutionCreator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PushSolutionCreator.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PushSolutionCreator.cs	(revision 15289)
@@ -1,4 +1,3 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.SolutionCreator {
-  using System;
 
   using HeuristicLab.Common;
@@ -9,4 +8,5 @@
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
 
   /// <summary>
@@ -34,4 +34,6 @@
       if (!Parameters.ContainsKey(IN_INSTRUCTION_PROBABILITY))
         Parameters.Add(new FixedValueParameter<PercentValue>(IN_INSTRUCTION_PROBABILITY, new PercentValue(0.05)));
+
+      Parameters.Add(new ValueLookupParameter<IReadOnlyExpressionsConfiguration>("Instructions", "The enabled instructions"));
     }
 
@@ -68,4 +70,9 @@
     }
 
+    public IValueLookupParameter<IReadOnlyExpressionsConfiguration> InstructionsParameter
+    {
+      get { return (IValueLookupParameter<IReadOnlyExpressionsConfiguration>)Parameters["Instructions"]; }
+    }
+
     //public IValueParameter<IntValue> MaxLengthParameter
     //{
@@ -94,21 +101,24 @@
       var result = new IntegerVector(len);
 
-      var variableLength = random.Next(MinLength, len);
-      var contentLength = Math.Min(variableLength, len);
+      var contentLength = random.Next(MinLength, len);
       var lowerBound = bounds[0, 0];
       var upperBound = bounds[0, 1];
-      var inInstructionRelativeProbability = ErcOptions.ErcProbability + InInstructionProbability;
+      //var inInstructionRelativeProbability = ErcOptions.ErcProbability + InInstructionProbability;
+      //var instructions = InstructionsParameter.ActualValue;
 
       for (var i = 0; i < contentLength; i++) {
-        var x = random.NextDouble();
+        //var x = random.NextDouble();
 
-        if (ErcOptions.ErcProbability > 0 &&
-            x <= ErcOptions.ErcProbability)
-          result[i] = PushSolutionEncoding.Erc;
-        else if (InInstructionProbability > 0 &&
-                 x <= inInstructionRelativeProbability)
-          result[i] = PushSolutionEncoding.In;
-        else
-          result[i] = random.Next(lowerBound, upperBound);
+        //if (ErcOptions.ErcProbability > 0 && x <= ErcOptions.ErcProbability) {
+        //  result[i] = PushSolutionEncoding.Erc;
+        //} else if (InInstructionProbability > 0 && x <= inInstructionRelativeProbability && instructions.InExpressionCount > 0) {
+        //  var index = random.Next(0, instructions.InExpressionCount);
+        //  var expression = ExpressionTable.InExpressionTable[index];
+
+        //  instructions.EnabledExpressions
+        //  //result[i] = PushSolutionEncoding.In;
+        //} else {
+        result[i] = random.Next(lowerBound, upperBound);
+        //}
       }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPrintStack.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPrintStack.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPrintStack.cs	(revision 15289)
@@ -1,4 +1,4 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Stack {
-  public interface IPrintStack : IPushStack<string> {
+  public interface IPrintStack : IPushStack {
     void NewLine();
     void Push<T>(T item);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPushStack.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPushStack.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPushStack.cs	(revision 15289)
@@ -16,4 +16,10 @@
     void Push(IReadOnlyList<T> items);
     void Push(IEnumerable<T> items);
+    void Swap(int count);
+    void Yank(int index);
+    void RemoveTop();
+    void Remove(int count);
+    void RemoveAt(int index);
+    void RemoveAt(int index, int count);
     new void Clear();
     IReadOnlyList<T> Peek(int count);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPushStackBase.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPushStackBase.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPushStackBase.cs	(revision 15289)
@@ -9,10 +9,5 @@
 
     void Clear();
-    void Swap(int count);
-    void Yank(int index);
-    void RemoveTop();
-    void Remove(int count);
-    void RemoveAt(int index);
-    void RemoveAt(int index, int count);
+
     IEnumerable<string> AsStrings();
     IEnumerable<object> AsObjects();
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/InterpreterStackStringifier.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/InterpreterStackStringifier.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/InterpreterStackStringifier.cs	(revision 15289)
@@ -44,5 +44,5 @@
     }
 
-    private static IEnumerable<string> StringifyLiteralStack<T>(IPushStack<T> stack, string prefix = "", string postfix = "", bool reverse = true) {
+    private static IEnumerable<string> StringifyLiteralStack(IPushStack stack, string prefix = "", string postfix = "", bool reverse = true) {
       var result = stack.AsStrings();
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PrintStack.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PrintStack.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PrintStack.cs	(revision 15289)
@@ -6,4 +6,5 @@
   using System.Collections.Generic;
 
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Constants;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
 
@@ -12,22 +13,10 @@
   /// </summary>
   public class PrintStack : IPrintStack {
-    private string currentTop;
-    private readonly IPushStack<string> stack = new PushStack<string>();
+    private int lineCount = 0;
     private readonly StringBuilder stringBuilder = new StringBuilder();
 
-    private string CurrentTop
-    {
-      get
-      {
-        return currentTop ?? (currentTop = stringBuilder.ToString());
-      }
-    }
-
-    public IEnumerator<string> GetEnumerator() {
-      return stack.GetEnumerator();
-    }
-
     IEnumerator IEnumerable.GetEnumerator() {
-      return GetEnumerator();
+      var lines = AsStrings();
+      return lines.GetEnumerator();
     }
 
@@ -36,185 +25,52 @@
     }
 
-    void IPushStack<string>.Clear() {
-      stack.Clear();
+    void IPushStack.Clear() {
       stringBuilder.Clear();
-      currentTop = null;
-    }
-
-    public IReadOnlyList<string> Peek(int count) {
-      if (count == 1)
-        return new[] { CurrentTop };
-
-      var peek = stack.Peek(count - 1);
-      var result = new List<string>(peek) { CurrentTop };
-
-      return result;
-    }
-
-    public void Insert(int index, string item) {
-      if (index == 0)
-        Add(item);
-
-      stack.Insert(index - 1, item);
-    }
-
-    public string Pop() {
-      var result = CurrentTop;
-
-      var top = stack.Pop();
-      SetBuilderToTop(top);
-
-      return result;
-    }
-
-    public IReadOnlyList<string> Pop(int count) {
-      if (count == 1)
-        return new[] { Pop() };
-
-      var popped = stack.Pop(count - 1);
-      var result = new List<string>(popped) { CurrentTop };
-
-      var newTop = stack.Pop();
-      SetBuilderToTop(newTop);
-
-      return result;
-    }
-
-    private void ClearTop() {
-      stringBuilder.Clear();
-      currentTop = null;
-    }
-
-    private void SetBuilderToTop(string top) {
-      stringBuilder.Clear();
-      stringBuilder.Append(top);
-      currentTop = top;
-    }
-
-    public bool TryPop(out string item) {
-      if (string.IsNullOrEmpty(CurrentTop)) {
-        item = null;
-        return false;
-      }
-
-      item = Pop();
-      return true;
-    }
-
-    public string ElementAt(int index) {
-      if (index == 0)
-        return CurrentTop;
-
-      return stack.ElementAt(index - 1);
-    }
-
-    public string Top
-    {
-      get
-      {
-        return CurrentTop;
-      }
-      set
-      {
-        SetBuilderToTop(value);
-      }
-    }
-
-    public string TopOrDefault { get { return CurrentTop; } }
-
-    public string Bottom { get { return Count > 1 ? stack.Bottom : CurrentTop; } }
-
-    public string BottomOrDefault { get { return Bottom; } }
-
-    public string this[int key]
-    {
-      get
-      {
-        return key == 0 ? CurrentTop : stack[key - 1];
-      }
-      set
-      {
-        if (key == 0)
-          SetBuilderToTop(value);
-        else
-          stack[key - 1] = value;
-      }
-    }
-
-    public int Count
-    {
-      get
-      {
-        return stack.Count + (string.IsNullOrEmpty(CurrentTop) ? 0 : 1);
-      }
     }
 
     public void NewLine() {
-      if (IsEmpty) return;
-
-      stack.Push(CurrentTop);
-      ClearTop();
+      stringBuilder.Append(PushEnvironment.NewLine);
+      lineCount++;
     }
 
     public void Push<T>(T item) {
+      if (IsEmpty) lineCount = 1;
       stringBuilder.Append(item);
-      currentTop = null;
     }
 
     public void Push(float item) {
+      if (IsEmpty) lineCount = 1;
       stringBuilder.Concat(item);
-      currentTop = null;
     }
 
     public void Push(double item) {
+      if (IsEmpty) lineCount = 1;
       stringBuilder.Concat(item);
-      currentTop = null;
     }
 
     public void Push(long item) {
+      if (IsEmpty) lineCount = 1;
       stringBuilder.Concat(item);
-      currentTop = null;
     }
 
     public void Push(int item) {
+      if (IsEmpty) lineCount = 1;
       stringBuilder.Concat(item);
-      currentTop = null;
     }
 
     public void Push(char item) {
+      if (IsEmpty) lineCount = 1;
       stringBuilder.Append(item);
-      currentTop = null;
     }
 
     public void Push(bool item) {
+      if (IsEmpty) lineCount = 1;
       stringBuilder.Append(item);
-      currentTop = null;
     }
 
 
     public void Push(string item) {
+      if (IsEmpty) lineCount = 1;
       stringBuilder.Append(item);
-      currentTop = null;
-    }
-
-    public void Push(string item1, string item2) {
-      stringBuilder.Append(item1);
-      stringBuilder.Append(item2);
-      currentTop = null;
-    }
-
-    public void Push(string item1, string item2, string item3) {
-      stringBuilder.Append(item1);
-      stringBuilder.Append(item2);
-      stringBuilder.Append(item3);
-      currentTop = null;
-    }
-
-    public void Push(string item1, string item2, string item3, string item4) {
-      stringBuilder.Append(item1);
-      stringBuilder.Append(item2);
-      stringBuilder.Append(item3);
-      stringBuilder.Append(item4);
-      currentTop = null;
     }
 
@@ -222,6 +78,4 @@
       for (var i = startIndex; i < items.Count; i++)
         stringBuilder.Append(items[i]);
-
-      currentTop = null;
     }
 
@@ -233,71 +87,9 @@
       foreach (var item in items)
         stringBuilder.Append(item);
-
-      currentTop = null;
-    }
-
-    void IPushStack.Clear() {
-      stringBuilder.Clear();
-      currentTop = null;
-      stack.Clear();
-    }
-
-    public void Swap(int count) {
-      stack.Push(CurrentTop);
-      stack.Swap(count);
-
-      var newTop = stack.Pop();
-      SetBuilderToTop(newTop);
-    }
-
-    public void Yank(int index) {
-      if (index == Count - 1) return;
-
-      stack.Push(CurrentTop);
-
-      var item = stack[index];
-      stack.RemoveAt(index);
-      SetBuilderToTop(item);
-    }
-
-    public void RemoveTop() {
-      var newTop = stack.Pop();
-      SetBuilderToTop(newTop);
-    }
-
-    public void Remove(int count) {
-      if (count == 1)
-        RemoveTop();
-
-      stack.Remove(count - 1);
-      var newTop = stack.Pop();
-      SetBuilderToTop(newTop);
-    }
-
-    public void RemoveAt(int index) {
-      if (index == 0)
-        ClearTop();
-      else
-        stack.RemoveAt(index - 1);
-    }
-
-    public void RemoveAt(int index, int count) {
-      if (index == 0)
-        count--;
-
-      stack.RemoveAt(index - 1, count);
-
-      if (index == 0) {
-        var newTop = stack.Pop();
-        SetBuilderToTop(newTop);
-      }
     }
 
     public IEnumerable<string> AsStrings() {
-      foreach (var item in stack)
-        yield return item;
-
-      if (!IsEmpty)
-        yield return CurrentTop;
+      var lines = stringBuilder.ToString().Split(PushEnvironment.NewLine);
+      return lines;
     }
 
@@ -306,49 +98,21 @@
     }
 
-    void ICollection<string>.Clear() {
-      stack.Clear();
-      stringBuilder.Clear();
-    }
-
-    public bool Contains(string item) {
-
-      return CurrentTop.Equals(item) || stack.Contains(item);
-    }
-
-    public void CopyTo(string[] array, int arrayIndex) {
-      stack.CopyTo(array, arrayIndex);
-      array[arrayIndex + stack.Count] = CurrentTop;
-    }
-
-    public bool Remove(string item) {
-      if (item.Equals(CurrentTop)) {
-        RemoveTop();
-        return true;
-      }
-
-      return stack.Remove(item);
-    }
-
-    int IPushStack<string>.Count
+    int IPushStack.Count
     {
       get
       {
-        return Count;
+        return lineCount;
       }
     }
 
-    public bool IsEmpty { get { return stack.IsEmpty && string.IsNullOrEmpty(CurrentTop); } }
+    public bool IsEmpty { get { return stringBuilder.Length == 0; } }
 
     public bool IsEnabled { get; set; }
 
-    int ICollection<string>.Count
-    {
-      get
-      {
-        return Count;
-      }
+    public bool IsReadOnly { get { return false; } }
+
+    public override string ToString() {
+      return stringBuilder.ToString();
     }
-
-    public bool IsReadOnly { get { return false; } }
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs	(revision 15289)
@@ -9,7 +9,9 @@
   using Core.Views;
   using Expressions;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Solution;
+
   using Interpreter;
   using MainForm;
-  using Problem;
   using Stack;
 
@@ -227,7 +229,6 @@
 
       // align numbers right
-      var stackEntryType = type.GetStackEntryType();
-      if (stackEntryType == typeof(double) ||
-          stackEntryType == typeof(long)) {
+      if (type == StackTypes.Integer ||
+          type == StackTypes.Float) {
         list.DrawMode = DrawMode.OwnerDrawFixed;
         list.DrawItem += (sender, e) => {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/RandomWalkTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/RandomWalkTests.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/RandomWalkTests.cs	(revision 15289)
@@ -5,4 +5,5 @@
 
   using HeuristicLab.BenchmarkSuite.Problems;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Evaluator;
 
   using Microsoft.VisualStudio.TestTools.UnitTesting;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Components/LexicaseTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Components/LexicaseTests.cs	(revision 15289)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Components/LexicaseTests.cs	(revision 15289)
@@ -0,0 +1,14 @@
+﻿namespace HeuristicLab.Tests.Components {
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  public class LexicaseTests {
+    [TestMethod]
+    [TestCategory("Problem")]
+    [TestProperty("Time", "short")]
+    public void TestLexicase() {
+      // how to test this?
+      //var selected = LexicaseSelector.Apply()
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Components/PrintStackTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Components/PrintStackTests.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Components/PrintStackTests.cs	(revision 15289)
@@ -20,5 +20,5 @@
       printStack.Push(100L);
 
-      Assert.AreEqual(100L.ToString(), printStack.Top);
+      Assert.AreEqual(100L.ToString(), printStack.ToString());
     }
 
@@ -27,5 +27,5 @@
       printStack.Push(100.5D);
 
-      Assert.AreEqual(100.5D.ToString(), printStack.Top);
+      Assert.AreEqual(100.5D.ToString(), printStack.ToString());
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 15289)
@@ -39,4 +39,7 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.Algorithms.GeneticAlgorithm-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Algorithms.GeneticAlgorithm-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Collections-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
@@ -59,7 +62,14 @@
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Encodings.IntegerVectorEncoding-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Operators-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Operators-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Optimization-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Optimization-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.ParallelEngine-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.ParallelEngine-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.Problems.Instances-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
@@ -70,4 +80,11 @@
       <SpecificVersion>False</SpecificVersion>
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Random-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Selection-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Selection-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.SequentialEngine-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.SequentialEngine-3.3.dll</HintPath>
     </Reference>
     <Reference Include="System" />
@@ -89,4 +106,5 @@
     <Compile Include="Benchmark\RandomWalkTests.cs" />
     <Compile Include="Benchmark\SolutionTests.cs" />
+    <Compile Include="Components\LexicaseTests.cs" />
     <Compile Include="Components\PrintStackTests.cs" />
     <Compile Include="Erc\ErcTests.cs" />
@@ -110,4 +128,5 @@
     <Compile Include="Interpreter\Expressions\VectorExpressionTests.cs" />
     <Compile Include="Interpreter\ExpressionTest.cs" />
+    <Compile Include="Problem\DeterministicTests.cs" />
     <Compile Include="Problem\IndividualMapperTests.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
@@ -128,4 +147,5 @@
     </ProjectReference>
   </ItemGroup>
+  <ItemGroup />
   <Choose>
     <When Condition="'$(VisualStudioVersion)' == '10.0' And '$(IsCodedUITest)' == 'True'">
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/PrintExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/PrintExpressionTests.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/PrintExpressionTests.cs	(revision 15289)
@@ -18,5 +18,5 @@
       interpreter.Run(new FloatPrintExpression());
 
-      Assert.AreEqual(value.ToString("R", CultureInfo.InvariantCulture), interpreter.PrintStack.Top);
+      Assert.AreEqual(value.ToString("R", CultureInfo.InvariantCulture), interpreter.PrintStack.ToString());
     }
   }
